From ed8fa02507a900e7bb802aa7be4565cd2fcc7e3d Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Mar 21 2017 09:44:19 +0000
Subject: [PATCH 2/6] Add the Halp configuration panel


---

diff --git a/hubs/static/client/app/widgets/halp/Config.jsx b/hubs/static/client/app/widgets/halp/Config.jsx
new file mode 100644
index 0000000..9e81477
--- /dev/null
+++ b/hubs/static/client/app/widgets/halp/Config.jsx
@@ -0,0 +1,226 @@
+import React from 'react';
+import {
+  IntlProvider,
+  defineMessages,
+  injectIntl,
+  FormattedMessage,
+  } from 'react-intl';
+import CompletionInput from '../../components/CompletionInput.jsx';
+
+
+const messages = defineMessages({
+  title_add: {
+    id: "hubs.widgets.halp.config.title.add",
+    defaultMessage: "Adding \"halp\" widget",
+  },
+  title_edit: {
+    id: "hubs.widgets.halp.config.title.edit",
+    defaultMessage: "Configuring \"halp\" widget",
+  },
+  followed_hubs: {
+    id: "hubs.widgets.halp.config.followed_hubs",
+    defaultMessage: "Followed hubs:",
+  },
+  no_hubs: {
+    id: "hubs.widgets.halp.config.no_hubs",
+    defaultMessage: "No hubs. Use the form to the right to add some.",
+  },
+  main_title: {
+    id: "hubs.widgets.halp.config.main_title",
+    defaultMessage: "Track help requests in hubs",
+  },
+  main_subtitle: {
+    id: "hubs.widgets.halp.config.main_subtitle",
+    defaultMessage: "Enter a team name below to add it to the list of hubs this widget will follow.",
+  },
+  placeholder: {
+    id: "hubs.widgets.halp.config.placeholder",
+    defaultMessage: "Enter team name here...",
+  },
+  add: {
+    id: "hubs.widgets.halp.config.add",
+    defaultMessage: "Add",
+  },
+  per_page: {
+    id: "hubs.widgets.halp.config.per_page",
+    defaultMessage: "Requests per page:",
+  },
+  per_page_help: {
+    id: "hubs.widgets.halp.config.per_page_help",
+    defaultMessage: "The number of requests per page to display.",
+  },
+  close: {
+    id: "hubs.widgets.halp.config.close",
+    defaultMessage: "Close",
+  },
+  cancel: {
+    id: "hubs.widgets.halp.config.cancel",
+    defaultMessage: "Cancel",
+  },
+  save: {
+    id: "hubs.widgets.halp.config.save",
+    defaultMessage: "Save",
+  },
+  remove_widget: {
+    id: "hubs.widgets.halp.config.remove_widget",
+    defaultMessage: "Remove this widget",
+  },
+});
+
+
+export default class Config extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.state = this.props.initialState;
+    this.addHub = this.addHub.bind(this);
+    this.removeHub = this.removeHub.bind(this);
+    this.onAddClick = this.onAddClick.bind(this);
+  }
+
+  addHub(name) {
+    // React may batch state updates:
+    // https://facebook.github.io/react/docs/state-and-lifecycle.html#state-updates-may-be-asynchronous
+    this.setState(function(prevState, props) {
+      if (prevState.hubs.indexOf(name) === -1) {
+        prevState.hubs.push(name);
+      }
+      return {hubs: prevState.hubs};
+    });
+  }
+
+  removeHub(name) {
+    // React may batch state updates:
+    // https://facebook.github.io/react/docs/state-and-lifecycle.html#state-updates-may-be-asynchronous
+    this.setState(function(prevState, props) {
+      prevState.hubs.splice(prevState.hubs.indexOf(name), 1);
+      return {hubs: prevState.hubs};
+    });
+  }
+
+  onAddClick(e) {
+    e.preventDefault();
+    var hubName = $(this.formDom).find("input[name='hub-add']").val();
+    this.addHub(hubName);
+  }
+
+  render() {
+    var titleMsg, followedHubs;
+    if (this.props.mode == "add") {
+      titleMsg = messages.title_add;
+    } else {
+      titleMsg = messages.title_edit;
+    }
+
+    followedHubs = this.state.hubs.map(function(hub, idx) {
+      return (
+        <li key={hub}>
+          <span className="hub">{hub}</span>
+          <span className="fa fa-times remove-hub"
+                onClick={(e) => this.removeHub(hub)}
+            />
+        </li>
+        );
+    }.bind(this));
+
+    const IntlCompletionInput = injectIntl((props) => (
+        <CompletionInput
+          name="hub-add"
+          url={props.urls.hubs}
+          spinner={props.urls.spinnerCircle}
+          placeholder={props.intl.formatMessage(messages.placeholder)}
+          />
+    ));
+
+    return (
+      <IntlProvider locale={navigator.language}>
+        <div className={"modal-dialog widget-halp-config widget-" + this.props.mode}>
+          <div className="modal-content">
+            <form method="post" action={this.props.urls.post}
+                  ref={(ref) => this.formDom = ref}>
+              <div className="modal-header">
+                <button type="button" className="close" data-dismiss="modal">&times;</button>
+                <h4 className="modal-title">
+                  <FormattedMessage {...titleMsg} />
+                </h4>
+              </div>
+              <div className="modal-body row">
+                <div className="col-sm-4 hubs-list">
+                  <FormattedMessage {...messages.followed_hubs} tagName="h5" />
+                  {this.state.hubs.length === 0 ?
+                    <FormattedMessage {...messages.no_hubs} tagName="p" />
+                  :
+                    <ul className="list-unstyled">
+                      {followedHubs}
+                    </ul>
+                  }
+                </div>
+                <div className="col-sm-8 form-side">
+                  <FormattedMessage {...messages.main_title} tagName="h4" />
+                  <FormattedMessage {...messages.main_subtitle} tagName="p" />
+                  <input type="hidden" name="hubs" value={this.state.hubs.join(",")} />
+                  <fieldset className="row">
+                    <div className="col-sm-9">
+                      <IntlCompletionInput {...this.props} />
+                    </div>
+                    <div className="col-sm-3">
+                      <button className="btn btn-info" onClick={this.onAddClick}>
+                        <FormattedMessage {...messages.add} />
+                      </button>
+                    </div>
+                  </fieldset>
+                  <fieldset className="row">
+                    <label className="col-sm-6 control-label">
+                      <FormattedMessage {...messages.per_page} />
+                    </label>
+                    <div className="col-sm-6">
+                      <input
+                        name="per_page"
+                        type="number"
+                        value={this.state.per_page}
+                        onChange={(e) => this.setState({per_page: e.target.value})}
+                        className="form-control input-sm"
+                        />
+                    </div>
+                    <div className="col-sm-12 text-muted">
+                      <FormattedMessage {...messages.per_page_help} tagName="small" />
+                    </div>
+                  </fieldset>
+                </div>
+              </div>
+              <div className="modal-footer">
+                <button type="button" className="btn btn-default" data-dismiss="modal">
+                  {this.props.mode === "add" ?
+                    <FormattedMessage {...messages.cancel} />
+                  :
+                    <FormattedMessage {...messages.close} />
+                  }
+                </button>
+                <button type="submit" className="btn btn-primary"
+                        disabled={this.state.hubs.length === 0 ? true : null}>
+                {this.props.mode === "add" ?
+                    <FormattedMessage {...messages.add} />
+                :
+                    <FormattedMessage {...messages.save} />
+                }
+                </button>
+              </div>
+            </form>
+            {this.props.mode !== "add" &&
+              <form method="POST" action={this.props.urls.remove} className="modal-footer p-abs" >
+                  <button type="submit" className="btn btn-danger" id="delete_widget">
+                    <FormattedMessage {...messages.remove_widget} />
+                  </button>
+              </form>
+            }
+          </div>
+        </div>
+      </IntlProvider>
+    );
+  }
+
+}
+
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/widgets/halp/Halp.js b/hubs/static/client/app/widgets/halp/Halp.js
new file mode 100644
index 0000000..5b821f5
--- /dev/null
+++ b/hubs/static/client/app/widgets/halp/Halp.js
@@ -0,0 +1,4 @@
+import Widget from './Widget.jsx';
+import Config from './Config.jsx';
+
+module.exports = {Widget, Config};
diff --git a/hubs/static/client/app/widgets/halp/Widget.jsx b/hubs/static/client/app/widgets/halp/Widget.jsx
new file mode 100644
index 0000000..71234a4
--- /dev/null
+++ b/hubs/static/client/app/widgets/halp/Widget.jsx
@@ -0,0 +1,182 @@
+import React from 'react';
+import {
+  IntlProvider,
+  defineMessages,
+  FormattedMessage,
+  } from 'react-intl';
+import HubsList from './HubsList.jsx';
+import ModalRequest from './ModalRequest.jsx';
+import ModalAllRequests from './ModalAllRequests.jsx';
+import Request from './Request.jsx';
+
+
+const messages = defineMessages({
+  no_request: {
+    id: "hubs.widgets.halp.no_request",
+    defaultMessage: "No request for now."
+  },
+  view_more: {
+    id: "hubs.widgets.halp.view_more",
+    defaultMessage: "View more"
+  },
+  zoom_title: {
+    id: "hubs.widgets.halp.zoom.title",
+    defaultMessage: "Help request"
+  },
+  search_title: {
+    id: "hubs.widgets.halp.search.title",
+    defaultMessage: "All Help Requests"
+  },
+});
+
+
+export default class Widget extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      requests: [],
+      inactiveHubs: [],
+      zoomedRequest: null,
+      allRequestsOpen: false,
+      loading: false
+    };
+    this.zoomOnRequest = this.zoomOnRequest.bind(this);
+    this.onZoomClose = this.onZoomClose.bind(this);
+    this.openAllRequests = this.openAllRequests.bind(this);
+    this.onAllRequestsClose = this.onAllRequestsClose.bind(this);
+    this.onHubClick = this.onHubClick.bind(this);
+  }
+
+  loadFromServer() {
+    this.setState({loading: true});
+    var data = { hubs: [] };
+    this.props.hubs.forEach(function(hub) {
+      if (this.state.inactiveHubs.indexOf(hub) === -1) {
+        data.hubs.push(hub);
+      }
+    }.bind(this));
+    this.serverRequest = $.ajax({
+      url: this.props.urls.data,
+      method: 'GET',
+      data: $.param(data, true),
+      dataType: 'json',
+      cache: false,
+      success: function(data) {
+        this.setState({
+          requests: data.requests,
+          loading: false
+        });
+      }.bind(this),
+      error: function(xhr, status, err) {
+        console.error(this.props.urls.data, status, err.toString());
+        this.setState({loading: false});
+      }.bind(this)
+    });
+  }
+
+  componentDidMount() {
+    this.loadFromServer();
+  }
+
+  componentWillUnmount() {
+    this.serverRequest.abort();
+  }
+
+  zoomOnRequest(request) {
+    this.setState({zoomedRequest: request});
+  }
+  onZoomClose() {
+    this.setState({zoomedRequest: null});
+  }
+
+  openAllRequests(e) {
+    e.preventDefault();
+    this.setState({allRequestsOpen: true});
+  }
+  onAllRequestsClose() {
+    this.setState({allRequestsOpen: false});
+  }
+
+  onHubClick(hubName) {
+    var newInactiveHubs = this.state.inactiveHubs.slice(),
+        inactiveIndex = this.state.inactiveHubs.indexOf(hubName);
+    if (inactiveIndex === -1) {
+      newInactiveHubs.push(hubName);
+    } else {
+      newInactiveHubs.splice(inactiveIndex, 1);
+    }
+    this.setState(
+      { inactiveHubs: newInactiveHubs },
+      this.loadFromServer);
+  }
+
+  render() {
+    var requestNodes;
+    if (this.state.requests.length === 0) {
+      requestNodes = (
+        <p className="no-request">
+          <FormattedMessage {...messages.no_request} />
+        </p>
+        );
+    } else {
+      var previousDate = null;
+      requestNodes = this.state.requests.map(function(request, idx) {
+        var showDate = (request.date !== previousDate);
+        previousDate = request.date;
+        return (
+          <Request
+            request={request}
+            showdate={showDate}
+            onZoomRequest={this.zoomOnRequest}
+            key={idx} />
+        );
+      }.bind(this));
+    }
+    var hubs = this.props.hubs.map(function(hub) {
+      return {
+        name: hub,
+        active: (this.state.inactiveHubs.indexOf(hub) === -1)
+      }
+    }.bind(this));
+    return (
+      <IntlProvider locale={navigator.language}>
+        <div className="widget-halp">
+          <HubsList
+            hubs={hubs}
+            onHubClick={this.onHubClick}
+            />
+          { this.state.loading ?
+              <img className="center-block" src={this.props.urls.spinner} />
+            :
+              <div className="requests">
+                {requestNodes}
+              </div>
+          }
+          <div className="view-more text-muted">
+            <button className="btn btn-secondary" onClick={this.openAllRequests}>
+              <FormattedMessage {...messages.view_more} />
+              &nbsp; <span className="fa fa-chevron-right" aria-hidden="true"></span>
+            </button>
+          </div>
+          <ModalRequest
+            open={this.state.zoomedRequest !== null}
+            data={this.state.zoomedRequest}
+            title={<FormattedMessage {...messages.zoom_title} />}
+            onHidden={this.onZoomClose} />
+          <ModalAllRequests
+            open={this.state.allRequestsOpen}
+            onHidden={this.onAllRequestsClose.bind(this)}
+            onZoomRequest={this.zoomOnRequest}
+            title={<FormattedMessage {...messages.search_title} />}
+            urls={this.props.urls}
+            hubs={hubs}
+            />
+        </div>
+      </IntlProvider>
+    );
+  }
+}
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/webpack.config.js b/hubs/static/client/webpack.config.js
index 4bd3fd9..f197a0e 100644
--- a/hubs/static/client/webpack.config.js
+++ b/hubs/static/client/webpack.config.js
@@ -10,7 +10,7 @@ const config = {
     entry: {
         Hubs: path.join(PATHS.app, 'core', 'Hubs.js'),
         Feed: path.join(PATHS.app, 'widgets', 'feed', 'Feed.jsx'),
-        Halp: path.join(PATHS.app, 'widgets', 'halp', 'Halp.jsx')
+        Halp: path.join(PATHS.app, 'widgets', 'halp', 'Halp.js')
     },
     output: {
         path: PATHS.build,
diff --git a/hubs/widgets/halp/__init__.py b/hubs/widgets/halp/__init__.py
index 92df5a4..474fc83 100644
--- a/hubs/widgets/halp/__init__.py
+++ b/hubs/widgets/halp/__init__.py
@@ -2,9 +2,11 @@ from __future__ import unicode_literals
 
 
 import arrow
+import flask
 
 from hubs.widgets.base import Widget
 from hubs.widgets import validators
+from .views import add_view, hubs_suggest_view
 
 
 class Halp(Widget):
@@ -33,3 +35,22 @@ class Halp(Widget):
         env = super(Halp, self).get_template_environment()
         env.filters['humanize'] = lambda d: arrow.get(d).humanize()
         return env
+
+    def get_add_url(self, hub, position):
+        return "%s?position=%s" % (
+            flask.url_for('halp_config_add', hub=hub.name), position)
+
+    def get_edit_url(self, hub, widget_instance):
+        return flask.url_for(
+            'halp_config', hub=hub.name, idx=widget_instance.idx)
+
+    def register_routes(self, app):
+        super(Halp, self).register_routes(app)
+        # Add the widget add view
+        rule = "/<hub>/w/%s/add" % self.name
+        endpoint = "%s_config_add" % self.name
+        app.add_url_rule(rule, endpoint=endpoint, view_func=add_view)
+        # Add the hubs suggestion view
+        rule = "/w/%s/hubs" % self.name
+        endpoint = "%s_config_hubs" % self.name
+        app.add_url_rule(rule, endpoint=endpoint, view_func=hubs_suggest_view)
diff --git a/hubs/widgets/halp/views.py b/hubs/widgets/halp/views.py
index 1aaf1ad..46d530e 100644
--- a/hubs/widgets/halp/views.py
+++ b/hubs/widgets/halp/views.py
@@ -4,6 +4,9 @@ import datetime
 import flask
 import time
 
+from hubs.models import Hub
+from hubs.views.utils import get_hub
+from hubs.widgets import registry
 from hubs.widgets.base import WidgetView
 from .functions import GetRequests
 
@@ -139,6 +142,9 @@ class SearchView(WidgetView):
 
 
 class RequestersView(WidgetView):
+    """
+    Returns suggestions for the "requesters" filter.
+    """
 
     name = "requesters"
     url_rules = ["requesters"]
@@ -158,3 +164,62 @@ class RequestersView(WidgetView):
             ])
         results = sorted(list(results))[:self.MAX_SUGGESTS]
         return flask.jsonify({"results": results})
+
+
+class ConfigView(WidgetView):
+    """
+    The custom configuration panel.
+    """
+
+    name = "config"
+    url_rules = ["config"]
+    template_name = "halp_config.html"
+
+    def get_context(self, instance, *args, **kwargs):
+        post_url = flask.url_for(
+            'widget_edit', hub=instance.hub.name, idx=instance.idx)
+        initial = instance.config.copy()
+        return dict(
+            mode="edit",
+            url=post_url,
+            initial=initial,
+            )
+
+
+def hubs_suggest_view():
+    """
+    Returns suggestions for the "hubs" list in the configuration.
+    """
+    MAX_SUGGESTS = 5
+    results = Hub.query
+    if flask.request.args.get("q"):
+        results = results.filter(Hub.name.ilike(
+            "%s%%" % flask.request.args.get("q")))
+    results = results.order_by(Hub.name)[:MAX_SUGGESTS]
+    return flask.jsonify({"results": [h.name for h in results]})
+
+
+def add_view(hub):
+    """The custom configuration panel when adding the widget.
+
+    This is not a subclass of WidgetView because it is not specific
+    to a widget instance, therefore it does not have the same URL
+    parameters.
+    """
+    hub = get_hub(hub)
+    widget = registry["halp"]
+    tpl_env = widget.get_template_environment()
+    template = tpl_env.get_template("halp_config.html")
+    post_url = "%s?position=%s" % (
+        flask.url_for('widget_add', hub=hub.name, widget="halp"),
+        flask.request.args.get("position"))
+    initial = dict(
+        (param.name, param.default)
+        for param in widget.get_parameters()
+        )
+    initial["hubs"] = [hub.name]
+    return template.render(
+        mode="add",
+        url=post_url,
+        initial=initial,
+    )

